-- File-Revision: 5
-- cooldown stuff

function cooldownTimer_OnUpdate(self, elapsed)
  self.elapsed = self.elapsed + elapsed;
  if self.elapsed > .1 then
    cooldownTimer_CheckTimer(self);
    self.elapsed = 0;
  end
end

function cooldownTimer_SetTime(timer)
  local timeleft = timer.time - GetTime();

  if timeleft < 0 then
    timer.time = 0;
    timer.text:SetText("");
  elseif timeleft < 1 then
    timer.text:SetFontObject("CooldownFontSmall");
    timer.text:SetText(("%.1f"):format(timeleft));
  elseif timeleft < 60 then
    timer.text:SetFontObject("CooldownFontLarge");
    timer.text:SetText(("%d"):format(timeleft));
  elseif timeleft < 3600 then
    timeleft = floor(timeleft/60);
    timer.text:SetFontObject("CooldownFontLarge");
    timer.text:SetText(("%dm"):format(timeleft));
  else
    timeleft = floor(timeleft/3600);
    timer.text:SetFontObject("CooldownFontLarge");
    timer.text:SetText(("%dh"):format(timeleft));
  end
end

function cooldownTimer_UpdateAction(button)
  local timer = _G[button:GetName().."CooldownTimer"]
  timer = timer or cooldownTimer_CreateTimer(button);
   if button.action and HasAction(button.action) then
    cooldownTimer_CheckTimer(timer);
    timer:Show();
  else
    timer:Hide();
  end
end

do 
  hooksecurefunc("ActionButton_Update",cooldownTimer_UpdateAction);
end

function cooldownTimer_CreateTimer(self)
  local frameName = self:GetName().."CooldownTimer";
  
  local frame = CreateFrame("FRAME",frameName,self,"CooldownTimerTemplate");

  frame:RegisterEvent("ACTIONBAR_UPDATE_STATE");
  
  frame.text:SetText("");
  frame.text:SetTextColor(1.0,0.1,0.1);
  
  frame.time = 0;
  frame.elapsed = 0;
  
  frame.parent = self;
  
  local frameLevel = self.cooldown:GetFrameLevel();
  frame:SetFrameLevel(frameLevel + 5);
  
  return frame;
end

function cooldownTimer_OnEvent(self, event, arg1)
  cooldownTimer_CheckTimer(self);
end

function cooldownTimer_CheckTimer(timer)
  local action = timer.parent.action

  if action and HasAction(action) then
    local start, duration, enable, charges, maxcharges = GetActionCooldown(action);
    
    if enable and enable > 0 and start and start > 0 and duration > 1.5 then
      timer.time = duration + start;
      timer.text:Show();
      cooldownTimer_SetTime(timer);
    else
      timer.text:Hide();
    end
  end
end